[2 days left] What’s wrong with your cloud strategy? Learn why multicloud solutions matter with Nimble Storage.Register Now

x
?
Solved

How i can read AutoCad DWG file using ObjectARX SDK ?

Posted on 2003-11-05
8
Medium Priority
?
2,472 Views
Last Modified: 2007-12-19
How i can read AutoCad DWG file using ObjectARX SDK ?

Anyone have any idea please inform me..?
0
Comment
Question by:Dhanushdas
[X]
Welcome to Experts Exchange

Add your voice to the tech community where 5M+ people just like you are talking about what matters.

  • Help others & share knowledge
  • Earn cash & points
  • Learn & ask questions
8 Comments
 
LVL 86

Expert Comment

by:jkr
ID: 9687162
Get the ObjectARX samples on this issue from http://usa.autodesk.com/adsk/servlet/item?siteID=123112&id=773180
0
 
LVL 86

Expert Comment

by:jkr
ID: 9687198
'AcDbDatabase::readDwgFile()' is what you should look for in the above samples...
0
 

Author Comment

by:Dhanushdas
ID: 9691899
Yes...I am looking for 'AcDbDatabase::readDwgFile()'.How i can get souce code for reading all autocad objects in a DWG file.?
0
VIDEO: THE CONCERTO CLOUD FOR HEALTHCARE

Modern healthcare requires a modern cloud. View this brief video to understand how the Concerto Cloud for Healthcare can help your organization.

 
LVL 86

Accepted Solution

by:
jkr earned 2000 total points
ID: 9694940
>>How i can get souce code

Download the aforementioned samples...
0
 
LVL 15

Expert Comment

by:OMC2000
ID: 9695501
If you want to list ALL object you should learn ObjectARX anyway.

Some helpful hints
How to get entities:
ARX\DOCSAMPS\TESTDB\TESTDB.CPP

void
readDwg()
{
    // Set constructor parameter to kFalse so that the
    // database will be constructed empty.  This way only
    // what is read in will be in the database.
    //
    AcDbDatabase *pDb = new AcDbDatabase(Adesk::kFalse);

    // The AcDbDatabase::readDwgFile() function
    // automatically appends a DWG extension if it is not
    // specified in the filename parameter.
    //
    pDb->readDwgFile("test1.dwg");

    // Open the model space block table record.
    //
    AcDbBlockTable *pBlkTbl;
    pDb->getSymbolTable(pBlkTbl, AcDb::kForRead);

    AcDbBlockTableRecord *pBlkTblRcd;
    pBlkTbl->getAt(ACDB_MODEL_SPACE, pBlkTblRcd,
        AcDb::kForRead);
    pBlkTbl->close();

    AcDbBlockTableRecordIterator *pBlkTblRcdItr;
    pBlkTblRcd->newIterator(pBlkTblRcdItr);

    AcDbEntity *pEnt;
    for (pBlkTblRcdItr->start(); !pBlkTblRcdItr->done();
        pBlkTblRcdItr->step())
    {
        pBlkTblRcdItr->getEntity(pEnt,
            AcDb::kForRead);
        acutPrintf("classname: %s\n",
            (pEnt->isA())->name());
        pEnt->close();
    }
    pBlkTblRcd->close();
    delete pBlkTblRcdItr;
    delete pDb;
}

Notice that there are various levels of AutoCAD objects visibility and various location of them.
Sample above lists top level objects available in model space.

The following types of objects can not be found this way:
- subentities In order to get them use
        AcDbObjectIterator  *pIter = NULL;
        if (pEnt->isKindOf(AcDbBlockReference::desc())) {
              // Block Reference  - get Attribute iterator
            pIter = AcDbBlockReference::cast(pEnt)->attributeIterator() ;
        } else if (pEnt->isKindOf(AcDb2dPolyline::desc())) {
              // 2D Polyline - get vertex iterator
            pIter = AcDb2dPolyline::cast(pEnt)->vertexIterator() ;
        } else if (pEnt->isKindOf(AcDb3dPolyline::desc())) {
              // 3D Polyline - get vertex iterator
            pIter = AcDb3dPolyline::cast(pEnt)->vertexIterator() ;
        } else if (pEnt->isKindOf(AcDbPolyFaceMesh::desc())) {
              // Polyface Mesh - get subobject iterator
            pIter = AcDbPolyFaceMesh::cast(pEnt)->vertexIterator() ;
        } else if (pEnt->isKindOf(AcDbPolygonMesh::desc())) {
              // Polygon Mesh - get vertex iterator
            pIter = AcDbPolygonMesh::cast(pEnt)->vertexIterator() ;
        }

- Symbol Table records in order to get them use
    AcDbSymbolTable mpSymbolTable;

// Block
     mErrStat = mpDwg->getBlockTable( mpSymbolTable, AcDb::kForRead );
// Layer
          mErrStat = mpDwg->getLayerTable( mpSymbolTable, AcDb::kForRead);
// TextStyle:
         mErrStat = mpDwg->getTextStyleTable(mpSymbolTable, AcDb::kForRead);
// LineType
         mErrStat = mpDwg->getLinetypeTable(mpSymbolTable, AcDb::kForRead);
// View    
        mErrStat = mpDwg->getViewTable( mpSymbolTable, AcDb::kForRead);
// ViewPort
        mErrStat = mpDwg->getViewportTable( mpSymbolTable, AcDb::kForRead);
// UCS         
        mErrStat = mpDwg->getUCSTable( mpSymbolTable, AcDb::kForRead);
// RegApp  
        mErrStat = mpDwg->getRegAppTable( mpSymbolTable, AcDb::kForRead);
// DimStyle
        mErrStat = mpDwg->getDimStyleTable( mpSymbolTable, AcDb::kForRead);

        mErrStat = mpSymbolTable->newIterator( pIter,
                                              true,
                                              true/*Skip Deleted*/ )

// dictionaries

// Group  
 mErrStat = mpDwg->getGroupDictionary( mpDict, AcDb::kForRead);
// Layout  
mErrStat = mpDwg->getLayoutDictionary( mpDict, AcDb::kForRead);
// MLStyle
mErrStat = mpDwg->getMLStyleDictionary( mpDict, AcDb::kForRead);
// PlotStyleName :
AcDbDictionaryWithDefault   *pDictWD      = NULL;
mErrStat = mpDwg->getPlotStyleNameDictionary( pDictWD, AcDb::kForRead);
if( Acad::eOk == mErrStat )
  mpDict = AcDbDictionary::cast(pDictWD);
// NamedDict:
 if( !strcmp(pName/*dictionary name*/, ACDB_PLOTSETTINGS_DICTIONARY)) {
    mErrStat = mpDwg->getPlotSettingsDictionary( mpDict, AcDb::kForRead);
    break;
 }
 mErrStat = mpDwg->getNamedObjectsDictionary( pDict, AcDb::kForRead);
 if( !pName && Acad::eOk == mErrStat ) {
    mpDict = pDict;
    break;
 }
 if( Acad::eOk == (mErrStat = pDict->getAt(pName, pObj, AcDb::kForRead))) {
    if( NULL == (mpDict = AcDbDictionary::cast(pObj))) {
      pObj->close();
      mErrStat = Acad::eWrongObjectType;
   }
 }

// extension disctionary that can be attached to any object

    dictObjId = pObj->extensionDictionary();
    pObj->close();

    // Open the extension dictionary  
    acdbOpenObject(pDict, dictObjId, AcDb::kForRead);


0
 
LVL 9

Expert Comment

by:tinchos
ID: 10242550
No comment has been added lately, so it's time to clean up this TA.
I will leave the following recommendation for this question in the Cleanup topic area:

Accept: jkr {http:#9694940}

Please leave any comments here within the next seven days.
PLEASE DO NOT ACCEPT THIS COMMENT AS AN ANSWER!

Tinchos
EE Cleanup Volunteer
0
 
LVL 15

Expert Comment

by:OMC2000
ID: 10250762
I gave detailed description of drawing reading procedure. It's much more useful answer than other ones.
0

Featured Post

Hire Technology Freelancers with Gigs

Work with freelancers specializing in everything from database administration to programming, who have proven themselves as experts in their field. Hire the best, collaborate easily, pay securely, and get projects done right.

Question has a verified solution.

If you are experiencing a similar issue, please ask a related question

Often, when implementing a feature, you won't know how certain events should be handled at the point where they occur and you'd rather defer to the user of your function or class. For example, a XML parser will extract a tag from the source code, wh…
Container Orchestration platforms empower organizations to scale their apps at an exceptional rate. This is the reason numerous innovation-driven companies are moving apps to an appropriated datacenter wide platform that empowers them to scale at a …
The goal of the video will be to teach the user the concept of local variables and scope. An example of a locally defined variable will be given as well as an explanation of what scope is in C++. The local variable and concept of scope will be relat…
The viewer will be introduced to the member functions push_back and pop_back of the vector class. The video will teach the difference between the two as well as how to use each one along with its functionality.

656 members asked questions and received personalized solutions in the past 7 days.

Join the community of 500,000 technology professionals and ask your questions.

Join & Ask a Question